var express = require('express');
var router = express.Router();
var jwt = require('jwt-simple');
var { networkInterfaces } = require('os');

/* GET home page. */
router.get('/', function(req, res, next) {
  var ip = 'localhost';
  const nets = networkInterfaces();
  for (const name of Object.keys(nets)) {
      for (const net of nets[name]) {
          if (net.family === 'IPv4' && !net.internal) {
              ip = net.address;
              break;
          }
      }
  }
  res.render('index', { title: 'Express', ip });
});

router.get('/file/', function(req, res, next) {
  res.contentType('application/pdf');
  res.download(`${__dirname}/prueba.pdf`);
});

router.post('/file/', function(req, res, next) {
  if (req.headers.authorization) {
    const parts = req.headers.authorization.split(' ');
    const token = parts[1];
    if (parts[0] === 'JWT') {
      if (token) {
        let tokenDecoded;
        try {
            tokenDecoded = jwt.decode(token, 'ADSIB');
        } catch (error) {
            throw Error('Falló la autenticación del token.');
        }
        /*res.status(402).json({
          mensaje: 'Error de prueba'
        });*/
        const fs = require('fs');
        fs.writeFileSync(`${__dirname}/firmado.pdf`, Buffer.from(req.body.base64, 'base64'));
        res.status(201).json({
          mensaje: 'Archivo guardado correctamente.'
        });
      } else {
        res.status(402).json({
          mensaje: 'Debe proporcionar un token.'
        });
      }
    } else {
      res.status(402).json({
        mensaje: 'El token debe empezar con JWT.'
      });
    }
  } else {
    res.status(402).json({
      mensaje: 'Debe proporcionar credenciales de acceso.'
    });
  }
});

module.exports = router;
